#include <QDateTime>
#include <QCoreApplication>
#include "cprocessrequest.h"
#include <QFile>
//https://github.com/azadkuh/qhttp/blob/master/example/basic-server/main.cpp

QString cProcessRequest::createRespone(QString resText, QString action, QString to)
{
    QVariantMap myMap;
    myMap.insert("response",resText);
    myMap.insert("action",action);
    myMap.insert("to",to);
    return jsonObj.createJsonString(myMap);
}

cProcessRequest::cProcessRequest()
{
    isInit = false;
}

cProcessRequest::~cProcessRequest()
{
}

void cProcessRequest::init()
{
    controller.init();
}

void cProcessRequest::actionPost(quint64 id, QHttpRequest *req, QHttpResponse *res)
{
    req->collectData(1024);
    req->onEnd([this, req, res]() {
        QString data = QString(req->collectedData().constData());
        QString action;
        // read command init
        if (isInit == false)
        {
            bool ok = false;
            action = jsonObj.getValue(data,"init");
            int numDevices = action.toInt(&ok);
            if(ok && numDevices > 0)
            {
                QList<st_device_info> list;
                jsonObj.getListDevice(data,"devices",list);
                if(list.count() > 0)
                {
                    qDebug()<<"Inited "<<list.count()<< " devices";
                    controller.init(list);
                    isInit = true;
                    res->end(createRespone("OK","","").toLatin1().data());
                }
                res->end(createRespone("failed","","").toLatin1().data());
            }
            else
                res->end(createRespone("Init wrong number of device!","","").toLatin1().data());
        }
        else{
            action = jsonObj.getValue(data,"text");
            action.append(" ");
            qDebug()<<"Action: "<<action;
            res->setStatusCode(qhttp::ESTATUS_OK);      // status 200
            if(action.toLower() == "hello tom ") // Say hello
            {
                res->end(createRespone("Hello man!","","").toLatin1().data());
            }

            // get status
            else if(action.toLower().contains("tell me") && action.toLower().contains("status of"))
            {
                int idx = action.indexOf("status of ") + QString("status of ").length();
                QString subStr = action.mid(idx,action.length() - idx);
                QString response;
                bool found = false;
                for(int i = 0; i < controller.getNumberDevice();i++)
                {
                    if(subStr.contains(QString(controller.getDeviceName(i)).append(" "),Qt::CaseInsensitive))
                    {
                        response = controller.getStatusDevice(controller.getDeviceName(i));
                        found = true;
                    }
                }
                if(found == false)
                    response = QString("I don't know!");
                res->end(createRespone(response,"","").toLatin1().data());
            }
            // turn on
            else if(action.toLower().contains("turn on"))
            {
                int idx = action.indexOf("turn on ") + QString("turn on ").length();
                QString subStr = action.mid(idx,action.length() - idx);
                QString response;
                QString object;
                bool found = false;
                for(int i = 0; i < controller.getNumberDevice();i++)
                {
                    if(subStr.contains(QString(controller.getDeviceName(i)).append(" "),Qt::CaseInsensitive))
                    {
                        controller.setDeviceStatus(controller.getDeviceName(i),true,response);
                        object = controller.getDeviceName(i);
                        found = true;
                    }
                }

                // response
                if(response.toLower().contains("ok"))
                {
                    res->end(createRespone(response,"on",object).toLatin1().data());
                }
                else
                {
                    if(found == false)
                        response = QString("Sorry! I dont know the device!");
                    res->end(createRespone(response,"","").toLatin1().data());
                }
            }
            // turn off
            else if(action.toLower().contains("turn off"))
            {
                int idx = action.indexOf("turn off ") + QString("turn off ").length();
                QString subStr = action.mid(idx,action.length() - idx);
                QString response;
                QString object;
                bool found = false;
                for(int i = 0; i < controller.getNumberDevice();i++)
                {
                    if(subStr.contains(QString(controller.getDeviceName(i)).append(" "),Qt::CaseInsensitive))
                    {
                        controller.setDeviceStatus(controller.getDeviceName(i),false,response);
                        object = controller.getDeviceName(i);
                        found = true;
                    }
                }

                // response
                if(response.toLower().contains("ok"))
                {
                    res->end(createRespone(response,"off",object).toLatin1().data());
                }
                else
                {
                    if(found == false)
                        response = QString("Sorry! I dont know the device!");
                    res->end(createRespone(response,"","").toLatin1().data());
                }
            }
            else
                res->end(createRespone("Not supported!","","").toLatin1().data());
        }
    });

}

void cProcessRequest::onNewRequestFromClient(QHttpRequest *request, QHttpResponse *response)
{
    printf("New request!\n");
}
